【每天学习一点算法 2026/04/02】最长递增子序列

每天学习一点算法 2026/04/02

题目:最长递增子序列

给你一个整数数组 nums ,找到其中最长严格递增子序列的长度。

子序列 是由数组派生而来的序列,删除(或不删除)数组中的元素而不改变其余元素的顺序。例如,3,6,2,7 是数组 0,3,1,6,2,2,7 的子序列。

动态规划

动态规划就是先找规律

我们设 dp[i] 是截至下标 i 处最长严格递增子序列的长度,那么 dp[i] 的值应该等于他之前的最长严格递增子序列长度 + 1

我们需要向前找到 nums[j] < nums[i] 的项,找出其中最大的 dp 值。

typescript 复制代码
function lengthOfLIS(nums: number[]): number {
  const dp = new Array(nums.length).fill(1) // 初始化dp数组,最短子序列都是1
  // 遍历数组计算 dp 值
  for (let i = 1; i < nums.length; i++) {
    // 往前遍历元素,计算当前位置最长子序列长度
    for (let j = i - 1; j >= 0 ; j--) {
      if (nums[j] < nums[i]) {
        // 只有 nums[j] < nums[i] 时,才有可能是子序列
        // 找到前方最长的递增子序列 + 1
        dp[i] = Math.max(dp[i], dp[j] + 1)
      }
    }
  }
  return Math.max(...dp) // 返回最长的子序列长度
};
贪心算法 + 二分法

这个方法是看了官方题解才知道的

这个方法的核心就是:我们如果要保证子序列最长递增,那就得使每个上升的元素也就是下一个元素,尽可能的小,于是我们可以维护一个数组,使这个数组的最后一项为递增子序列的最小可能值。

我们以这个 [10,9,2,5,3,7,101,18] 为例

  • 第一项 10 只有一项肯定最短 [10]
  • 接下来 9,它是小于 10 , 后面大于 9 的数肯定是比大于 10 的数多的,直接替换 [9]
  • 接下来 2,同理直接替换 [2]
  • 接下来 5,他是大于我们最后一项 2 的,那么我们可以直接将它插入最长子序列 [2, 5]
  • 接下来 3,他是小于 5 的,那我们就需要在维护的数组里找到第一个大于它的元素,也就是 5 ,替换掉它 [2, 3]
  • 接下来 7,直接插入 [2, 3, 7]
  • 接下来 101,直接插入 [2, 3, 7, 101]
  • 接下来 18,替换掉第一个大于大的 101 [2, 3, 7, 18]

其实我们发现,这个流程下来得到的结果并不是我们最终的最长子序列,比如我们把 3 换成 1,最终结果就会变成 [1, 5, 7, 18],本来应该是 [2, 5, 7, 18],但是我们可以看出遇到小于最后一位我们只做了替换操作不会影响数组的长度,因为我们无法保证后续元素中小于末尾的元素个数,上面的例子是一个理想的情况,感觉只需要替换最后一个元素就行了,觉得有疑问的可以尝试一下 [9, 10, 1, 2, 3, 4],我们只有不断的往前替换元素,才能保证数组的最后一位是可能子序列的最小末尾数。

typescript 复制代码
function lengthOfLIS(nums: number[]): number {
  const res = [nums[0]] // 
  for (let i = 1; i < nums.length; i++) {
    if (res[res.length - 1] >= nums[i]) {
      let left = 0, right = res.length - 1, pos = nums.len - 1 // 默认替换末尾
      while (left <= right) {
        const mid = Math.floor((left + right) / 2)
        if (res[mid] >= nums[i]) {
          // 由于是向下取整的,所以需要在左边处理时记录当前位置为替换位置
          pos = mid
          right = mid - 1
        } else {
          // 第一个大于 nums[i] 右侧
          left = mid + 1
        }
      }
      res[pos] = nums[i] // 修改对应位置
    } else {
      res.push(nums[i]) // 末尾添加
    }
  }
  return res.length // 返回最终长度
};

题目来源:力扣(LeetCode)

相关推荐
敬往事一杯酒哈6 小时前
海康 AGV 导航读码器学习
学习
信奥卷王7 小时前
[GESP202609 六级] 分树规划
算法
夏幻灵7 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
qq_284274058 小时前
机械原理笔记:平面机构自由度计算(复合铰链、局部自由度、虚约束)与四杆机构入门(含考点)
笔记·学习·平面·自动化·制造
徐小黑ACG9 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
qq_284274059 小时前
数控铣床与加工中心笔记:铣刀与刀柄系统、G54试切对刀、镜像加工指令、孔加工工艺(钻扩铰镗)与固定循环G73/G83/G81/G76/G87/G84
笔记·学习·自动化·制造
Navigator_Z9 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
北极有牛10 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记10 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练